package Athena::ViewFarmAction;

use strict;

use Athena::WebAPI::Response;
use Athena::FarmView;
use Athena::Engine::Farm;
use Athena::Engine::Phys;

sub execute {
  my $stInvocant = shift(@_);
  my $rRequest = shift(@_);
  my $rConn = shift(@_);
  my %hParams = ( @_ );
  my $stParams = \%hParams;
  my $rResponse = undef;
  my $stActionName = 'ViewFarmAction';
  $rRequest->action($stActionName);
  my $stAction = $rRequest->param($stActionName);
  my $stErrMsg = "";
  my $stLb = $rRequest->cookie('AthenaEngineUrl') 
    || $rRequest->cookie('AthenaEngineHost') 
      . ":" . $rRequest->cookie('AthenaEnginePort');

  my $rFarms = Athena::Engine::Farm->new($rConn);
  $rFarms->refresh();
  my $rPhyss = Athena::Engine::Phys->new($rConn);
  $rPhyss->refresh();

  my $rHiddenFields = {
		       $rRequest->getActionParam() => $rRequest->action(),
		       $stActionName => '',
		      };

  my $rView = FarmView->new('lb' => $stLb,
			    'err_msg' => $stErrMsg,
			    'hidden_fields' => $rHiddenFields,
			    'action_name' => $stActionName,
			    'body_style' => $stParams->{body_style},
			    'table_style' => $stParams->{table_style},
			    'farms' => $rFarms,
			    'physs' => $rPhyss
			   );

  $rResponse = Response->new($rView);
  
  return $rResponse;
}

1;
